
module axiu_dwidth_downsizer_vwrapper #(
    parameter AXI_ADDR_WIDTH = 34,
    parameter AXI_SLV_DATA_WIDTH = 512,
    parameter AXI_MST_DATA_WIDTH = 256,
    parameter READ = 1,
    parameter WRITE = 1
) (
    input clk,
    input rstn,
    input [AXI_ADDR_WIDTH-1:0] slv_awaddr,
    input [7:0] slv_awlen,
    input [2:0] slv_awsize,
    input [1:0] slv_awburst,
    input slv_awlock,
    input [3:0] slv_awcache,
    input [2:0] slv_awprot,
    input [3:0] slv_awqos,
    input [3:0] slv_awregion,
    input slv_awvalid,
    output slv_awready,
    input [AXI_SLV_DATA_WIDTH-1:0] slv_wdata,
    input [AXI_SLV_DATA_WIDTH/8-1:0] slv_wstrb,
    input slv_wlast,
    input slv_wvalid,
    output slv_wready,
    output [1:0] slv_bresp,
    output slv_bvalid,
    input slv_bready,
    input [AXI_ADDR_WIDTH-1:0] slv_araddr,
    input [7:0] slv_arlen,
    input [2:0] slv_arsize,
    input [1:0] slv_arburst,
    input slv_arlock,
    input [3:0] slv_arcache,
    input [2:0] slv_arprot,
    input [3:0] slv_arqos,
    input [3:0] slv_arregion,
    input slv_arvalid,
    output slv_arready,
    output [AXI_SLV_DATA_WIDTH-1:0] slv_rdata,
    output [1:0] slv_rresp,
    output slv_rlast,
    output slv_rvalid,
    input slv_rready,
    output [AXI_ADDR_WIDTH-1:0] mst_awaddr,
    output [7:0] mst_awlen,
    output [2:0] mst_awsize,
    output [1:0] mst_awburst,
    output mst_awlock,
    output [3:0] mst_awcache,
    output [2:0] mst_awprot,
    output [3:0] mst_awqos,
    output [3:0] mst_awregion,
    output mst_awvalid,
    input mst_awready,
    output [AXI_MST_DATA_WIDTH-1:0] mst_wdata,
    output [AXI_MST_DATA_WIDTH/8-1:0] mst_wstrb,
    output mst_wlast,
    output mst_wvalid,
    input mst_wready,
    input [1:0] mst_bresp,
    input mst_bvalid,
    output mst_bready,
    output [AXI_ADDR_WIDTH-1:0] mst_araddr,
    output [7:0] mst_arlen,
    output [2:0] mst_arsize,
    output [1:0] mst_arburst,
    output mst_arlock,
    output [3:0] mst_arcache,
    output [2:0] mst_arprot,
    output [3:0] mst_arqos,
    output [3:0] mst_arregion,
    output mst_arvalid,
    input mst_arready,
    input [AXI_MST_DATA_WIDTH-1:0] mst_rdata,
    input [1:0] mst_rresp,
    input mst_rlast,
    input mst_rvalid,
    output mst_rready
);
    axiu_dwidth_downsizer_wrapper #(
        .AXI_ADDR_WIDTH(AXI_ADDR_WIDTH),
        .AXI_SLV_DATA_WIDTH(AXI_SLV_DATA_WIDTH),
        .AXI_MST_DATA_WIDTH(AXI_MST_DATA_WIDTH),
        .READ(READ),
        .WRITE(WRITE)
    ) axiu_dwidth_downsizer_wrapperI (
        .clk(clk),
        .rstn(rstn),
        .slv_aw_addr(slv_awaddr),
        .slv_aw_len(slv_awlen),
        .slv_aw_size(slv_awsize),
        .slv_aw_burst(slv_awburst),
        .slv_aw_lock(slv_awlock),
        .slv_aw_cache(slv_awcache),
        .slv_aw_prot(slv_awprot),
        .slv_aw_qos(slv_awqos),
        .slv_aw_region(slv_awregion),
        .slv_aw_valid(slv_awvalid),
        .slv_aw_ready(slv_awready),
        .slv_w_data(slv_wdata),
        .slv_w_strb(slv_wstrb),
        .slv_w_last(slv_wlast),
        .slv_w_valid(slv_wvalid),
        .slv_w_ready(slv_wready),
        .slv_b_resp(slv_bresp),
        .slv_b_valid(slv_bvalid),
        .slv_b_ready(slv_bready),
        .slv_ar_addr(slv_araddr),
        .slv_ar_len(slv_arlen),
        .slv_ar_size(slv_arsize),
        .slv_ar_burst(slv_arburst),
        .slv_ar_lock(slv_arlock),
        .slv_ar_cache(slv_arcache),
        .slv_ar_prot(slv_arprot),
        .slv_ar_qos(slv_arqos),
        .slv_ar_region(slv_arregion),
        .slv_ar_valid(slv_arvalid),
        .slv_ar_ready(slv_arready),
        .slv_r_data(slv_rdata),
        .slv_r_resp(slv_rresp),
        .slv_r_last(slv_rlast),
        .slv_r_valid(slv_rvalid),
        .slv_r_ready(slv_rready),
        .mst_aw_addr(mst_awaddr),
        .mst_aw_len(mst_awlen),
        .mst_aw_size(mst_awsize),
        .mst_aw_burst(mst_awburst),
        .mst_aw_lock(mst_awlock),
        .mst_aw_cache(mst_awcache),
        .mst_aw_prot(mst_awprot),
        .mst_aw_qos(mst_awqos),
        .mst_aw_region(mst_awregion),
        .mst_aw_valid(mst_awvalid),
        .mst_aw_ready(mst_awready),
        .mst_w_data(mst_wdata),
        .mst_w_strb(mst_wstrb),
        .mst_w_last(mst_wlast),
        .mst_w_valid(mst_wvalid),
        .mst_w_ready(mst_wready),
        .mst_b_resp(mst_bresp),
        .mst_b_valid(mst_bvalid),
        .mst_b_ready(mst_bready),
        .mst_ar_addr(mst_araddr),
        .mst_ar_len(mst_arlen),
        .mst_ar_size(mst_arsize),
        .mst_ar_burst(mst_arburst),
        .mst_ar_lock(mst_arlock),
        .mst_ar_cache(mst_arcache),
        .mst_ar_prot(mst_arprot),
        .mst_ar_qos(mst_arqos),
        .mst_ar_region(mst_arregion),
        .mst_ar_valid(mst_arvalid),
        .mst_ar_ready(mst_arready),
        .mst_r_data(mst_rdata),
        .mst_r_resp(mst_rresp),
        .mst_r_last(mst_rlast),
        .mst_r_valid(mst_rvalid),
        .mst_r_ready(mst_rready)
    );
endmodule
