
module eth_100G_rx_wrapper #(
    parameter FRAME_QUEUE_LEN = 0,
    parameter MAX_CLUSTER_SIZE = 0
) (
    input clk,
    input rstn,
    input [47:0] mac_addr,
    input rx_tvalid,
    input [511:0] rx_tdata,
    input [63:0] rx_tkeep,
    input rx_tuser,
    input rx_tlast,
    output so_tvalid,
    input so_tready,
    output [511:0] so_tdata,
    output [63:0] so_tkeep,
    output [7:0] so_tid,
    output so_tlast,
    input s_axi_awvalid,
    output s_axi_awready,
    input [13:0] s_axi_awaddr,
    input [2:0] s_axi_awprot,
    input s_axi_wvalid,
    output s_axi_wready,
    input [31:0] s_axi_wdata,
    input [3:0] s_axi_wstrb,
    output s_axi_bvalid,
    input s_axi_bready,
    output [1:0] s_axi_bresp,
    input s_axi_arvalid,
    output s_axi_arready,
    input [13:0] s_axi_araddr,
    input [2:0] s_axi_arprot,
    output s_axi_rvalid,
    input s_axi_rready,
    output [31:0] s_axi_rdata,
    output [1:0] s_axi_rresp
);
    eth_100G_rx #(
        .FRAME_QUEUE_LEN(FRAME_QUEUE_LEN),
        .MAX_CLUSTER_SIZE(MAX_CLUSTER_SIZE)
    ) eth_100G_rx_I (
        .clk(clk),
        .rstn(rstn),
        .mac_addr(mac_addr),
        .rx_tvalid(rx_tvalid),
        .rx_tdata(rx_tdata),
        .rx_tkeep(rx_tkeep),
        .rx_tuser(rx_tuser),
        .rx_tlast(rx_tlast),
        .so_tvalid(so_tvalid),
        .so_tready(so_tready),
        .so_tdata(so_tdata),
        .so_tkeep(so_tkeep),
        .so_tid(so_tid),
        .so_tlast(so_tlast),
        .s_axi_awvalid(s_axi_awvalid),
        .s_axi_awready(s_axi_awready),
        .s_axi_awaddr(s_axi_awaddr),
        .s_axi_awprot(s_axi_awprot),
        .s_axi_wvalid(s_axi_wvalid),
        .s_axi_wready(s_axi_wready),
        .s_axi_wdata(s_axi_wdata),
        .s_axi_wstrb(s_axi_wstrb),
        .s_axi_bvalid(s_axi_bvalid),
        .s_axi_bready(s_axi_bready),
        .s_axi_bresp(s_axi_bresp),
        .s_axi_arvalid(s_axi_arvalid),
        .s_axi_arready(s_axi_arready),
        .s_axi_araddr(s_axi_araddr),
        .s_axi_arprot(s_axi_arprot),
        .s_axi_rvalid(s_axi_rvalid),
        .s_axi_rready(s_axi_rready),
        .s_axi_rdata(s_axi_rdata),
        .s_axi_rresp(s_axi_rresp)
    );
endmodule
