
module message_sender_lfsr (
    input clk,
    input rstn,
    input step,
    input [23:0] seed,
    output [23:0] val
);

    reg [23:0] lfsr;
    wire output_bit;

    assign output_bit = lfsr[0] ^ lfsr[1] ^ lfsr[2] ^ lfsr[7];
    assign val = lfsr;

    always_ff @(posedge clk) begin

        if (step) begin
            lfsr <= {output_bit, lfsr[23:1]};
        end

        if (!rstn) begin
            lfsr <= seed;
        end
    end

endmodule
