
module pkt_dec_conn_info_mem #(
    parameter LEN = 64,
    parameter WIDTH = 0
) (
    input clk,
    input en,
    input we,
    input [$clog2(LEN)-1:0] addr,
    input [WIDTH-1:0] din,
    output reg [WIDTH-1:0] dout
);

    reg [WIDTH-1:0] mem[LEN];

    always_ff @(posedge clk) begin
        if (en) begin
            if (we) begin
                mem[addr] <= din;
            end else begin
                dout <= mem[addr];
            end
        end
    end

endmodule
